// Borland C++ Builder
// Copyright (c) 1995, 1998 by Borland International
// All rights reserved

// (DO NOT EDIT: machine generated header) 'TikClock.pas' rev: 3.00

#ifndef TikClockHPP
#define TikClockHPP
#include <Forms.hpp>
#include <Dialogs.hpp>
#include <ExtCtrls.hpp>
#include <Controls.hpp>
#include <Graphics.hpp>
#include <Classes.hpp>
#include <SysUtils.hpp>
#include <Messages.hpp>
#include <Windows.hpp>
#include <SysInit.hpp>
#include <System.hpp>

//-- user supplied -----------------------------------------------------------

namespace Tikclock
{
//-- type declarations -------------------------------------------------------
enum TTickingClockMode { tcmIdle, tcmChronoMeter, tcmClock };

class DELPHICLASS TTickingThread;
class DELPHICLASS TTickingClock;
class PASCALIMPLEMENTATION TTickingClock : public Controls::TGraphicControl 
{
	typedef Controls::TGraphicControl inherited;
	
private:
	Graphics::TBitmap* FBitmap;
	Graphics::TPen* FPen[3];
	Graphics::TBrush* FBrush[2];
	Byte FHour;
	Byte FMin;
	Byte FSec;
	int FSize[3];
	bool FAutoSize;
	TTickingClockMode FMode;
	Classes::TNotifyEvent FOnTick;
	void __fastcall SetBitmap(Graphics::TBitmap* ABitmap);
	void __fastcall SetPen(int Index, Graphics::TPen* APen);
	void __fastcall SetBrush(int Index, Graphics::TBrush* ABrush);
	void __fastcall SetHour(Byte Value);
	void __fastcall SetMin(Byte Value);
	void __fastcall SetSec(Byte Value);
	void __fastcall SetSize(int Index, int Value);
	void __fastcall SetMode(TTickingClockMode Value);
	
protected:
	tagPOINT Center;
	TTickingThread* TickThread;
	virtual void __fastcall Paint(void);
	void __fastcall ScreenObjectChange(System::TObject* Sender);
	void __fastcall BitmapChange(System::TObject* Sender);
	DYNAMIC void __fastcall DblClick(void);
	
public:
	__fastcall virtual TTickingClock(Classes::TComponent* AOwner);
	__fastcall virtual ~TTickingClock(void);
	virtual void __fastcall SetTime(Byte AHour, Byte AMin, Byte ASec);
	virtual void __fastcall SetSeconds(int ManySec);
	
__published:
	__property bool AutoSize = {read=FAutoSize, write=FAutoSize, default=1};
	__property Graphics::TBitmap* Bitmap = {read=FBitmap, write=SetBitmap};
	__property TTickingClockMode Mode = {read=FMode, write=SetMode, stored=false, default=0};
	__property Byte Hour = {read=FHour, write=SetHour, default=0};
	__property Byte Min = {read=FMin, write=SetMin, default=0};
	__property Byte Sec = {read=FSec, write=SetSec, default=0};
	__property Graphics::TPen* PenHour = {read=FPen[47], write=SetPen, index=0};
	__property Graphics::TPen* PenMin = {read=FPen[48], write=SetPen, index=1};
	__property Graphics::TPen* PenSec = {read=FPen[49], write=SetPen, index=2};
	__property Graphics::TBrush* BrushHour = {read=FBrush[50], write=SetBrush, index=0};
	__property Graphics::TBrush* BrushMin = {read=FBrush[51], write=SetBrush, index=1};
	__property int HourSize = {read=FSize[53], write=SetSize, index=0, nodefault};
	__property int MinSize = {read=FSize[54], write=SetSize, index=1, nodefault};
	__property int SecSize = {read=FSize[55], write=SetSize, index=2, nodefault};
	__property Classes::TNotifyEvent OnTick = {read=FOnTick, write=FOnTick};
	__property Enabled ;
	__property Visible ;
	__property OnClick ;
	__property OnDblClick ;
	__property OnMouseDown ;
	__property OnMouseMove ;
	__property OnMouseUp ;
};

class PASCALIMPLEMENTATION TTickingThread : public Classes::TThread 
{
	typedef Classes::TThread inherited;
	
protected:
	virtual void __fastcall Execute(void);
	void __fastcall Tick(void);
	
public:
	TTickingClock* Clock;
public:
	/* TThread.Create */ __fastcall TTickingThread(bool CreateSuspended) : Classes::TThread(CreateSuspended
		) { }
	/* TThread.Destroy */ __fastcall virtual ~TTickingThread(void) { }
	
};

//-- var, const, procedure ---------------------------------------------------
extern PACKAGE void __fastcall Register(void);

}	/* namespace Tikclock */
#if !defined(NO_IMPLICIT_NAMESPACE_USE)
using namespace Tikclock;
#endif
//-- end unit ----------------------------------------------------------------
#endif	// TikClock
